#!/usr/bin/env python
# -*- coding:utf-8 -*-

# ##############################################################################
#     Base code from where the autogenerated code inherits
#
#     Copyright (C) 2021 Alba Synchrotron/CELLS, Cerdanyola Spain
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see [http://www.gnu.org/licenses/].
# ##############################################################################

"""
This code contains the main launcher method for the DLLRF device server.
"""

__all__ = ["main"]

__author__ = 'sblanch'

__docformat__ = 'restructuredtext'

# standard library imports
import sys

# dependency imports
import tango

# local imports
from .dllrf import DLLRF, DLLRFClass

def main():
    try:
        tango_utils = tango.Util(sys.argv)
        db = tango.Database()
        classes = db.get_device_class_list(f"DLLRF/{sys.argv[1]}")[1::2]
        print(f"found {classes} classes for device server DLLRF")
        tango_utils.add_class(DLLRFClass, DLLRF, "DLLRF")

        u = tango.Util.instance()
        u.server_init()
        u.server_run()
    except tango.DevFailed as exception:
        print(f"DevFailed exception:{exception}")
    except Exception as exception:
        print(f"Unforseen exception: {exception}")


if __name__ == '__main__':
    main()
